VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Fall Down"
   ClientHeight    =   6510
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8985
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   434
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   599
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer3 
      Interval        =   50
      Left            =   2040
      Top             =   6000
   End
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   1560
      Top             =   6000
   End
   Begin VB.PictureBox Picture3 
      AutoRedraw      =   -1  'True
      Height          =   495
      Left            =   7680
      Picture         =   "falldown.frx":0000
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   4
      Top             =   6000
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      Height          =   495
      Left            =   6840
      Picture         =   "falldown.frx":07AE
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   3
      Top             =   6000
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   1080
      Top             =   6000
   End
   Begin VB.CommandButton Command1 
      Caption         =   "New"
      Height          =   495
      Left            =   0
      TabIndex        =   1
      Top             =   6000
      Width           =   1095
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      FillColor       =   &H0000C000&
      FillStyle       =   7  'Diagonal Cross
      Height          =   6000
      Left            =   0
      ScaleHeight     =   400
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   600
      TabIndex        =   0
      Top             =   0
      Width           =   9000
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "SCORE:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   495
      Left            =   5520
      TabIndex        =   6
      Top             =   6000
      Width           =   3375
   End
   Begin VB.Label Label2 
      Caption         =   "Key pad 4 = left, 6 = right, 8 starts new game, 2 pauses"
      Height          =   255
      Left            =   1200
      TabIndex        =   5
      Top             =   6120
      Width           =   4455
   End
   Begin VB.Label Label1 
      Caption         =   "1"
      Height          =   255
      Left            =   8520
      TabIndex        =   2
      Top             =   6120
      Visible         =   0   'False
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'these variables are for the block generating
Dim x As Integer
Dim y As Integer

'this variable is a multi-dimensional array for the matrix of blocks
Dim blocks(1 To 24, 1 To 18) As Integer

'this variable is to add spacing between rows
Dim spacer As Integer

'score variable is the intial score and score2 takes the decimals out of it
Dim score As Integer
Dim score2 As Integer

'this variable is more boolean in the code and stops the ball when it hits a block
Dim stopper As Integer

'location of ball
Dim ballx As Integer
Dim bally As Integer

'this program uses BitBlt to draw onto the screen.
'It is a small program to be using DirectX
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Const SRCCOPY = &HCC0020

'command1 starts a new game
Private Sub Command1_Click()

'reset score
score = 0

'reset matrix
For x = 1 To 24
    For y = 1 To 18
        blocks(x, y) = 0
    Next
Next

'really dont need this, but sometimes you do
'i added it so when you hit keys it will read the ascii
Picture1.SetFocus

'start the game timers
Timer1.Enabled = True
Timer2.Enabled = True

'set initial ball position
ballx = 12
bally = 2

'generate first couple rows of blocks at the bottom
For x = 1 To 24
    For y = 15 To 17
        blocks(x, y) = Rnd * 1
        If blocks(x, y) = 1 Then
            BitBlt Picture1.hDC, (x * 25) - 25, (y * 25) - 25, 25, 25, Picture3.hDC, 0, 0, SRCCOPY
        End If
        'below is to generate 4 rows of spacing
        y = y + 4
    Next
Next
      
'set first spacer to 1
spacer = 1

End Sub

Private Sub Picture1_KeyPress(KeyAscii As Integer)

'puts the ascii number in the label.
Label1.Caption = KeyAscii

End Sub

Private Sub Picture1_KeyUp(KeyCode As Integer, Shift As Integer)
'puts a 1 in the label if nothing is being touched
Label1.Caption = "1"
End Sub

Private Sub Timer1_Timer()
'clear the picture box so you don't see garbage
'refresh wont cause it to flicker
'cls is to clear it every time
Picture1.Refresh
Picture1.Cls

'takes the decimals out of the score
score2 = (score / 8)

'puts the score ont he screen
Label3.Caption = "SCORE: " & score2

'moves parts of the matrix up one and paints new blocks
For x = 1 To 24
    For y = 1 To 17
        blocks(x, y) = blocks(x, y + 1)
        If blocks(x, y) = 1 Then
            BitBlt Picture1.hDC, (x * 25) - 25, (y * 25) - 25, 25, 25, Picture3.hDC, 0, 0, SRCCOPY
        End If
    Next
Next

'adds one to our spacer
spacer = spacer + 1

'when spacer equals 5 then it generates new blocks
'when it isnt 5 then it just makes blanks
If spacer = 5 Then
    spacer = 1
    For x = 1 To 24
        blocks(x, 18) = Rnd * 1
    Next
Else
    For x = 1 To 24
        blocks(x, 18) = 0
    Next
End If

'paint the ball
BitBlt Picture1.hDC, (ballx * 25) - 25, (bally * 25) - 25, 25, 25, Picture2.hDC, 0, 0, SRCCOPY

End Sub

Private Sub Timer2_Timer()

'tells you you screwed up :P and stops the game
If bally <= 1 Then
    Timer1.Enabled = False
    Timer2.Enabled = False
    MsgBox "You Lose"
End If

'if there is an error then ignore it
'usually if there is it is just a little one
On Error Resume Next

'if the ball can't go down it stops it
If blocks(ballx, bally + 1) = 1 Then
    bally = bally - 1
    stopper = 1
    Exit Sub
'if there is a space then the ball drops
ElseIf blocks(ballx, bally + 2) = 0 Then
    stopper = 0
    If stopper = 0 Then
       bally = bally + 1
       score = score + (bally / 2)
    End If
    'keeps the ball from going under the screen
    If bally >= 16 Then
        bally = 16
    End If
End If


End Sub

Private Sub Timer3_Timer()

'these move the ball left to right
If Label1.Caption = "54" Then
    If ballx >= 23 Then
        ballx = 23
    End If
    ballx = ballx + 1
    score = score + 1
ElseIf Label1.Caption = "52" Then
    If ballx <= 2 Then
        ballx = 2
    End If
    ballx = ballx - 1
    score = score + 1
'starts new game
ElseIf Label1.Caption = "56" Then
    Command1_Click
'stops timers to pause
ElseIf Label1.Caption = "50" Then
    If Timer1.Enabled = True Then
        Timer1.Enabled = False
        Timer2.Enabled = False
    Else
        Timer1.Enabled = True
        Timer2.Enabled = True
    End If
End If


End Sub
